import{s as Se,n as je,o as ke}from"../chunks/scheduler.9039eef2.js";import{S as Xe,i as We,g as a,s as n,r as p,A as Ye,h as s,f as l,c as o,j as He,u as m,x as r,k as Re,y as ze,a as i,v as d,d as c,t as f,w as h}from"../chunks/index.ded8f90d.js";import{C as ge}from"../chunks/CodeBlock.8580f3e8.js";import{H as z}from"../chunks/Heading.f027f30d.js";function Ne(be){let u,F,N,J,g,V,b,A,w,we="The examples should work in any of the following settings (with the same script):",D,_,_e="<li>single GPU</li> <li>multi GPUS (using PyTorch distributed mode)</li> <li>multi GPUS (using DeepSpeed ZeRO-Offload stages 1, 2, &amp; 3)</li> <li>fp16 (mixed-precision), fp32 (normal precision), or bf16 (bfloat16 precision)</li>",E,y,ye=`To run it in each of these various modes, first initialize the accelerate
configuration with <code>accelerate config</code>`,O,$,$e="<strong>NOTE to train with a 4-bit or 8-bit model</strong>, please run",I,x,q,T,Q,M,xe="For all the examples, you’ll need to generate a 🤗 Accelerate config file with:",K,U,ee,v,Te="Then, it is encouraged to launch jobs with <code>accelerate launch</code>!",te,C,le,P,Me='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/sft.py" rel="nofollow"><code>examples/scripts/sft.py</code></a></td> <td>This script shows how to use the <code>SFTTrainer</code> to fine tune a model or adapters into a target dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/reward_modeling.py" rel="nofollow"><code>examples/scripts/reward_modeling.py</code></a></td> <td>This script shows how to use the <code>RewardTrainer</code> to train a reward model on your own dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo.py" rel="nofollow"><code>examples/scripts/ppo.py</code></a></td> <td>This script shows how to use the <code>PPOTrainer</code> to fine-tune a sentiment analysis model using IMDB dataset</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo_multi_adapter.py" rel="nofollow"><code>examples/scripts/ppo_multi_adapter.py</code></a></td> <td>This script shows how to use the <code>PPOTrainer</code> to train a single base model with multiple adapters. Requires you to run the example script with the reward model training beforehand.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/stable_diffusion_tuning_example.py" rel="nofollow"><code>examples/scripts/stable_diffusion_tuning_example.py</code></a></td> <td>This script shows to use DDPOTrainer to fine-tune a stable diffusion model using reinforcement learning.</td></tr></tbody>',ie,G,Ue="Here are also some easier-to-run colab notebooks that you can use to get started with TRL:",ne,L,ve='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/best_of_n.ipynb" rel="nofollow"><code>examples/notebooks/best_of_n.ipynb</code></a></td> <td>This notebook demonstrates how to use the “Best of N” sampling strategy using TRL when fine-tuning your model with PPO.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-sentiment.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-sentiment.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 imdb sentiment tuning example on a jupyter notebook.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-control.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-control.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 sentiment control example on a jupyter notebook.</td></tr></tbody>',oe,Z,Ce="We also have some other examples that are less maintained but can be used as a reference:",ae,H,Pe='<li><strong><a href="https://github.com/huggingface/trl/tree/main/examples/research_projects" rel="nofollow">research_projects</a></strong>: Check out this folder to find the scripts used for some research projects that used TRL (LM de-toxification, Stack-Llama, etc.)</li>',se,R,re,S,Ge="All of the scripts can be run on multiple GPUs by providing the path of an 🤗 Accelerate config file when calling <code>accelerate launch</code>. To launch one of them on one or multiple GPUs, run the following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine and <code>--all_arguments_of_the_script</code> with your arguments.)",pe,j,me,k,Le="You can also adjust the parameters of the 🤗 Accelerate config file to suit your needs (e.g. training in mixed precision).",de,X,ce,W,Ze="Most of the scripts can be run on multiple GPUs together with DeepSpeed ZeRO-{1,2,3} for efficient sharding of the optimizer states, gradients, and model weights. To do so, run following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine, <code>--all_arguments_of_the_script</code> with your arguments, and <code>--deepspeed_config</code> with the path to the DeepSpeed config file such as <code>examples/deepspeed_configs/deepspeed_zero1.yaml</code>):",fe,Y,he,B,ue;return g=new z({props:{title:"Examples",local:"examples",headingTag:"h1"}}),b=new z({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),x=new ge({props:{code:"cGlwJTIwaW5zdGFsbCUyMC0tdXBncmFkZSUyMHRybCU1QnF1YW50aXphdGlvbiU1RA==",highlighted:"pip install --upgrade trl[quantization]",wrap:!1}}),T=new z({props:{title:"Accelerate Config",local:"accelerate-config",headingTag:"h2"}}),U=new ge({props:{code:"YWNjZWxlcmF0ZSUyMGNvbmZpZyUyMCUyMyUyMHdpbGwlMjBwcm9tcHQlMjB5b3UlMjB0byUyMGRlZmluZSUyMHRoZSUyMHRyYWluaW5nJTIwY29uZmlndXJhdGlvbg==",highlighted:"accelerate config # will prompt you to define the training configuration",wrap:!1}}),C=new z({props:{title:"Maintained Examples",local:"maintained-examples",headingTag:"h1"}}),R=new z({props:{title:"Distributed training",local:"distributed-training",headingTag:"h2"}}),j=new ge({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRm11bHRpX2dwdS55YW1sJTIwLS1udW1fcHJvY2Vzc2VzJTIwJTdCTlVNX0dQVVMlN0QlMjBwYXRoX3RvX3NjcmlwdC5weSUyMC0tYWxsX2FyZ3VtZW50c19vZl90aGVfc2NyaXB0",highlighted:"accelerate launch --config_file=examples/accelerate_configs/multi_gpu.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),X=new z({props:{title:"Distributed training with DeepSpeed",local:"distributed-training-with-deepspeed",headingTag:"h3"}}),Y=new ge({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRmRlZXBzcGVlZF96ZXJvJTdCMSUyQzIlMkMzJTdELnlhbWwlMjAtLW51bV9wcm9jZXNzZXMlMjAlN0JOVU1fR1BVUyU3RCUyMHBhdGhfdG9fc2NyaXB0LnB5JTIwLS1hbGxfYXJndW1lbnRzX29mX3RoZV9zY3JpcHQ=",highlighted:"accelerate launch --config_file=examples/accelerate_configs/deepspeed_zero{1,2,3}.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),{c(){u=a("meta"),F=n(),N=a("p"),J=n(),p(g.$$.fragment),V=n(),p(b.$$.fragment),A=n(),w=a("p"),w.textContent=we,D=n(),_=a("ul"),_.innerHTML=_e,E=n(),y=a("p"),y.innerHTML=ye,O=n(),$=a("p"),$.innerHTML=$e,I=n(),p(x.$$.fragment),q=n(),p(T.$$.fragment),Q=n(),M=a("p"),M.textContent=xe,K=n(),p(U.$$.fragment),ee=n(),v=a("p"),v.innerHTML=Te,te=n(),p(C.$$.fragment),le=n(),P=a("table"),P.innerHTML=Me,ie=n(),G=a("p"),G.textContent=Ue,ne=n(),L=a("table"),L.innerHTML=ve,oe=n(),Z=a("p"),Z.textContent=Ce,ae=n(),H=a("ol"),H.innerHTML=Pe,se=n(),p(R.$$.fragment),re=n(),S=a("p"),S.innerHTML=Ge,pe=n(),p(j.$$.fragment),me=n(),k=a("p"),k.textContent=Le,de=n(),p(X.$$.fragment),ce=n(),W=a("p"),W.innerHTML=Ze,fe=n(),p(Y.$$.fragment),he=n(),B=a("p"),this.h()},l(e){const t=Ye("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(l),F=o(e),N=s(e,"P",{}),He(N).forEach(l),J=o(e),m(g.$$.fragment,e),V=o(e),m(b.$$.fragment,e),A=o(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1qml164"&&(w.textContent=we),D=o(e),_=s(e,"UL",{"data-svelte-h":!0}),r(_)!=="svelte-y1bwso"&&(_.innerHTML=_e),E=o(e),y=s(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1gk4czs"&&(y.innerHTML=ye),O=o(e),$=s(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1uwpnnm"&&($.innerHTML=$e),I=o(e),m(x.$$.fragment,e),q=o(e),m(T.$$.fragment,e),Q=o(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-8m9xl"&&(M.textContent=xe),K=o(e),m(U.$$.fragment,e),ee=o(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1fatpmt"&&(v.innerHTML=Te),te=o(e),m(C.$$.fragment,e),le=o(e),P=s(e,"TABLE",{"data-svelte-h":!0}),r(P)!=="svelte-pbgb4t"&&(P.innerHTML=Me),ie=o(e),G=s(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-8xuvqq"&&(G.textContent=Ue),ne=o(e),L=s(e,"TABLE",{"data-svelte-h":!0}),r(L)!=="svelte-17wv7zp"&&(L.innerHTML=ve),oe=o(e),Z=s(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-nr1j2l"&&(Z.textContent=Ce),ae=o(e),H=s(e,"OL",{"data-svelte-h":!0}),r(H)!=="svelte-ks8v1x"&&(H.innerHTML=Pe),se=o(e),m(R.$$.fragment,e),re=o(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1wqljqa"&&(S.innerHTML=Ge),pe=o(e),m(j.$$.fragment,e),me=o(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-12yw9zf"&&(k.textContent=Le),de=o(e),m(X.$$.fragment,e),ce=o(e),W=s(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-155h86t"&&(W.innerHTML=Ze),fe=o(e),m(Y.$$.fragment,e),he=o(e),B=s(e,"P",{}),He(B).forEach(l),this.h()},h(){Re(u,"name","hf:doc:metadata"),Re(u,"content",Be)},m(e,t){ze(document.head,u),i(e,F,t),i(e,N,t),i(e,J,t),d(g,e,t),i(e,V,t),d(b,e,t),i(e,A,t),i(e,w,t),i(e,D,t),i(e,_,t),i(e,E,t),i(e,y,t),i(e,O,t),i(e,$,t),i(e,I,t),d(x,e,t),i(e,q,t),d(T,e,t),i(e,Q,t),i(e,M,t),i(e,K,t),d(U,e,t),i(e,ee,t),i(e,v,t),i(e,te,t),d(C,e,t),i(e,le,t),i(e,P,t),i(e,ie,t),i(e,G,t),i(e,ne,t),i(e,L,t),i(e,oe,t),i(e,Z,t),i(e,ae,t),i(e,H,t),i(e,se,t),d(R,e,t),i(e,re,t),i(e,S,t),i(e,pe,t),d(j,e,t),i(e,me,t),i(e,k,t),i(e,de,t),d(X,e,t),i(e,ce,t),i(e,W,t),i(e,fe,t),d(Y,e,t),i(e,he,t),i(e,B,t),ue=!0},p:je,i(e){ue||(c(g.$$.fragment,e),c(b.$$.fragment,e),c(x.$$.fragment,e),c(T.$$.fragment,e),c(U.$$.fragment,e),c(C.$$.fragment,e),c(R.$$.fragment,e),c(j.$$.fragment,e),c(X.$$.fragment,e),c(Y.$$.fragment,e),ue=!0)},o(e){f(g.$$.fragment,e),f(b.$$.fragment,e),f(x.$$.fragment,e),f(T.$$.fragment,e),f(U.$$.fragment,e),f(C.$$.fragment,e),f(R.$$.fragment,e),f(j.$$.fragment,e),f(X.$$.fragment,e),f(Y.$$.fragment,e),ue=!1},d(e){e&&(l(F),l(N),l(J),l(V),l(A),l(w),l(D),l(_),l(E),l(y),l(O),l($),l(I),l(q),l(Q),l(M),l(K),l(ee),l(v),l(te),l(le),l(P),l(ie),l(G),l(ne),l(L),l(oe),l(Z),l(ae),l(H),l(se),l(re),l(S),l(pe),l(me),l(k),l(de),l(ce),l(W),l(fe),l(he),l(B)),l(u),h(g,e),h(b,e),h(x,e),h(T,e),h(U,e),h(C,e),h(R,e),h(j,e),h(X,e),h(Y,e)}}}const Be='{"title":"Examples","local":"examples","sections":[{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Accelerate Config","local":"accelerate-config","sections":[],"depth":2}],"depth":1}';function Fe(be){return ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends Xe{constructor(u){super(),We(this,u,Fe,Ne,Se,{})}}export{Ee as component};
